/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * The response when retrieving more than one range of values in a spreadsheet selected by
 * DataFilters.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BatchGetValuesByDataFilterResponse extends com.google.api.client.json.GenericJson {

  /**
   * The ID of the spreadsheet the data was retrieved from.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String spreadsheetId;

  /**
   * The requested values with the list of data filters that matched them.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<MatchedValueRange> valueRanges;

  /**
   * The ID of the spreadsheet the data was retrieved from.
   * @return value or {@code null} for none
   */
  public java.lang.String getSpreadsheetId() {
    return spreadsheetId;
  }

  /**
   * The ID of the spreadsheet the data was retrieved from.
   * @param spreadsheetId spreadsheetId or {@code null} for none
   */
  public BatchGetValuesByDataFilterResponse setSpreadsheetId(java.lang.String spreadsheetId) {
    this.spreadsheetId = spreadsheetId;
    return this;
  }

  /**
   * The requested values with the list of data filters that matched them.
   * @return value or {@code null} for none
   */
  public java.util.List<MatchedValueRange> getValueRanges() {
    return valueRanges;
  }

  /**
   * The requested values with the list of data filters that matched them.
   * @param valueRanges valueRanges or {@code null} for none
   */
  public BatchGetValuesByDataFilterResponse setValueRanges(java.util.List<MatchedValueRange> valueRanges) {
    this.valueRanges = valueRanges;
    return this;
  }

  @Override
  public BatchGetValuesByDataFilterResponse set(String fieldName, Object value) {
    return (BatchGetValuesByDataFilterResponse) super.set(fieldName, value);
  }

  @Override
  public BatchGetValuesByDataFilterResponse clone() {
    return (BatchGetValuesByDataFilterResponse) super.clone();
  }

}
