/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * Updates an embedded object's border property.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UpdateEmbeddedObjectBorderRequest extends com.google.api.client.json.GenericJson {

  /**
   * The border that applies to the embedded object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EmbeddedObjectBorder border;

  /**
   * The fields that should be updated. At least one field must be specified. The root `border` is
   * implied and should not be specified. A single `"*"` can be used as short-hand for listing every
   * field.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String fields;

  /**
   * The ID of the embedded object to update.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer objectId;

  /**
   * The border that applies to the embedded object.
   * @return value or {@code null} for none
   */
  public EmbeddedObjectBorder getBorder() {
    return border;
  }

  /**
   * The border that applies to the embedded object.
   * @param border border or {@code null} for none
   */
  public UpdateEmbeddedObjectBorderRequest setBorder(EmbeddedObjectBorder border) {
    this.border = border;
    return this;
  }

  /**
   * The fields that should be updated. At least one field must be specified. The root `border` is
   * implied and should not be specified. A single `"*"` can be used as short-hand for listing every
   * field.
   * @return value or {@code null} for none
   */
  public String getFields() {
    return fields;
  }

  /**
   * The fields that should be updated. At least one field must be specified. The root `border` is
   * implied and should not be specified. A single `"*"` can be used as short-hand for listing every
   * field.
   * @param fields fields or {@code null} for none
   */
  public UpdateEmbeddedObjectBorderRequest setFields(String fields) {
    this.fields = fields;
    return this;
  }

  /**
   * The ID of the embedded object to update.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getObjectId() {
    return objectId;
  }

  /**
   * The ID of the embedded object to update.
   * @param objectId objectId or {@code null} for none
   */
  public UpdateEmbeddedObjectBorderRequest setObjectId(java.lang.Integer objectId) {
    this.objectId = objectId;
    return this;
  }

  @Override
  public UpdateEmbeddedObjectBorderRequest set(String fieldName, Object value) {
    return (UpdateEmbeddedObjectBorderRequest) super.set(fieldName, value);
  }

  @Override
  public UpdateEmbeddedObjectBorderRequest clone() {
    return (UpdateEmbeddedObjectBorderRequest) super.clone();
  }

}
